#include "freemote.h"
#include <QDebug>
#include <QMetaEnum>
namespace FreeAPI
{
    FreeMote::FreeMote(const QString& code, Box box, QObject *parent) :
            QObject(parent)
    {
        mCode = code;
        mBox = box;
        mPressHttp = new QHttp(this);
        connect(mPressHttp,SIGNAL(done(bool)),this,SLOT(done(bool)));
    }



    void FreeMote::press(int channel)
    {
        QString channelString = QString::number(channel);
        QMetaEnum boxEnum = metaObject()->enumerator(metaObject()->indexOfEnumerator("Box"));
        QString boxString = boxEnum.key(mBox);
        boxString =boxString.toLower();

        int length = channelString.length();

        for ( int i=0; i<length; ++i)
        {
            QString isLong;
            if ( i < length -1)
                isLong = "&long=true";
            else
                isLong = "&long=false";

            QString path = "/pub/remote_control?code="+mCode+"&key="+channelString.at(i)+isLong;

            mPressHttp->setHost(boxString+".freebox.fr");
            mPressHttp->get(path);
        }
    }

    void FreeMote::press(Button button, bool isLong)
    {
        qDebug()<<"press";


        QMetaEnum btnEnum = metaObject()->enumerator(metaObject()->indexOfEnumerator("Button"));
        QMetaEnum boxEnum = metaObject()->enumerator(metaObject()->indexOfEnumerator("Box"));

        QString btnString = btnEnum.key(button);
        QString boxString = boxEnum.key(mBox);
        QString isLongSting;
        if ( isLong)
            isLongSting = "&long=true";
        else
            isLongSting = "&long=false";

        btnString =btnString.toLower();
        boxString =boxString.toLower();


        QString path = "/pub/remote_control?code="+mCode+"&key="+btnString+isLongSting;



        mPressHttp->setHost(boxString+".freebox.fr");
        mPressHttp->get(path);
    }

    void FreeMote::done(bool error)
    {
        if ( error)
            emit failed();
        else
            emit success();
    }
}
